力扣 | 128. 最长连续序列

力扣 | 128. 最长连续序列_第1张图片

public class _128_longest_consecutive_sequence {
    /*  leetcode 128 号算法题:最长连续序列

        给定一个未排序的整数数组 nums ,
        找出数字连续的最长序列(不要求序列元素在原数组中连续)的长度。

        输入:nums = [100,4,200,1,3,2]
        输出:4

        输入:nums = [0,3,7,2,5,8,4,6,0,1]
        输出:9

        0 <= nums.length <= 10^4
        -10^9 <= nums[i] <= 10^9

        进阶:你可以设计并实现时间复杂度为 O(n) 的解决方案吗?
     */

    // 排序解法
    // 时间复杂度:O(nlogn)
    // 空间复杂度:O(n)
    public int longestConsecutive1(int[] nums) {
        if (nums.length < 2) return nums.length;
/*sort()方法的时间复杂度为O(n log n),其中n是数组大小。sort()方法使用了基于比较的排序算法,
因此时间复杂度不能优化到O(n)。另一方面,sort()方法的空间复杂度为O(log n)。sort()方法在排序时使用了递归,
因此需要建立和执行函数调用堆栈。
*/
        Arrays.sort(nums);//排序时间复杂度O(nlogn),内部用归并排序O(n)

        int ans = 1;
        int count = 1;
        for (int i = 1; i < nums.length; i++) {
            if (nums[i] == nums[i - 1]) continue;

            if (nums[i] - nums[i - 1] == 1) {
                count++;
            } else {
                ans = Math.max(ans, count);
                count = 1;
            }
        }

        return Math.max(ans, count);
    }

    // 哈希查找解法
    // 时间复杂度:O(n)
    // 空间复杂度:O(n)
    public int longestConsecutive(int[] nums) {
        if (nums.length < 2) return nums.length;

        Set<Integer> set = new HashSet<>();
        for (Integer num : nums) set.add(num);

        int ans = 1;
        for (int num : nums) {
            // 这里会存在重复计算,为什么会产生以及如何解决,请参考 issue:
            // https://gitee.com/douma_edu/douma_algo_training_camp/issues/I4H4RZ
            if (set.contains(num - 1)) continue;

            int currNum = num;
            int count = 1;
            while (set.contains(currNum + 1)) {
                currNum += 1;
                count += 1;
            }

            ans = Math.max(ans, count);
        }

        return ans;
    }
}

你可能感兴趣的:(编程语言,算法学习,计算机基础,leetcode,算法,数据结构,java)